using System;
using System.Collections.Generic;

namespace StatePatternDemo
{
    public class FlightManager
    {
        private Dictionary<Int32, FlightState> _flights = new Dictionary<int, FlightState>();

        public FlightManager()
        {
            _flights.Add(123, new IdleState(123));
            _flights.Add(234, new IdleState(234));
            _flights.Add(345, new IdleState(345));
            _flights.Add(555, new IdleState(555));
        }

        public FlightState GetFlightState(int flightNumber)
        {
            return _flights[flightNumber];
        }

        public void UpdateFlightState(int flightNumber, FlightState state)
        {
            if ( _flights.ContainsKey(flightNumber))
            {
                _flights[flightNumber] = state;
            }
            else
            {
                _flights.Add(flightNumber, state);
            }
        }
    }

    public enum DelayReasons
    {
        None,
        Wind,
        Ice,
        Snow, 
        Maintenance,
        ItsMonday,
        CauseTheyCan
    }
}