﻿using System.Linq;
using System.Text;
using NUnit.Framework;

namespace StatePatternDemo
{
    [TestFixture]
    public class TestHarness
    {
        [Test]
        public void State()
        {
            var manager = new FlightManager();

            var flightState = manager.GetFlightState(123);
            System.Diagnostics.Debug.WriteLine(flightState.IsOnTime());
            System.Diagnostics.Debug.WriteLine(flightState.DelayReason);
            System.Diagnostics.Debug.WriteLine(flightState.DepartureTime);

            manager.UpdateFlightState(123, new WeatherDelayState(123, DelayReasons.Snow));

            flightState = manager.GetFlightState(123);
            System.Diagnostics.Debug.WriteLine(flightState.IsOnTime());
            System.Diagnostics.Debug.WriteLine(flightState.DelayReason);
            System.Diagnostics.Debug.WriteLine(flightState.DepartureTime);

            manager.UpdateFlightState(123, new InTransitState(123 ));

            flightState = manager.GetFlightState(123);
            System.Diagnostics.Debug.WriteLine(flightState.IsOnTime());
            System.Diagnostics.Debug.WriteLine(flightState.DelayReason);
            System.Diagnostics.Debug.WriteLine(flightState.DepartureTime);
        }
    }
}
